///////////////////////////////////////////////////////////////////  
//						USB tester
//						
//TESTING ONE, TWO, THREE.
///////////////////////////////////////////////////////////////////  

#include "base.h"
#include <Windows.h>
#include "fstream.h"
#include <string.h>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <cmath>

unsigned short buffer[BUFFERSIZE];//readout buffers
int RAW[CHAN][256];

float DNL_LUT[4096][CHAN];
float LUT[4096][CHAN];
int PED_DATA[CHAN][256];
unsigned int TRIG_SET;

using namespace std;

MainWND::MainWND()
{
    GoodData = false;
    lastGoodData = new unsigned short[BUFFERSIZE];  
}
/////////////////////////////////////////////////////  
//////////////////////////////////////
void MainWND::LOG_DATA(unsigned int NUM_READS, int trig_mode)
{
    LOAD_DNL_LUT();
    LOAD_PED();        
    unsigned int i,j,k;//,DEBUG; 
   // unsigned int NUM_READS = 1000;
    float sample;
    float pipedat[CHAN][256];
    float DNL_temp;
    
    ofstream LOGGED_DATA_CH1; 
    LOGGED_DATA_CH1.open ("LOG_DATA_CH1.txt");
    ofstream LOGGED_DATA_CH2; 
    LOGGED_DATA_CH2.open ("LOG_DATA_CH2.txt");
    ofstream LOGGED_DATA_CH3; 
    LOGGED_DATA_CH3.open ("LOG_DATA_CH3.txt");
    ofstream LOGGED_DATA_CH4; 
    LOGGED_DATA_CH4.open ("LOG_DATA_CH4.txt");
    ofstream LOGGED_DATA_CH5; 
    LOGGED_DATA_CH5.open ("LOG_DATA_CH5.txt");
    ofstream LOGGED_DATA_CH6; 
    LOGGED_DATA_CH6.open ("LOG_DATA_CH6.txt");
      
    for(k=0;k<NUM_READS; k++){
        printf("READOUT: %d of %d\n",k+1,NUM_READS);  
        
        if(trig_mode == 0) 
            SOFT_TRIG();//for debugging
        
        Sleep(1);
        Read(false);
              
        for(i=0;i<CHAN; i++){
            for(j=0;j<256; j++){
            
                sample = (float)RAW[i][j];
                sample =  DNL_LUT[(int)sample][i];  // convert to voltage using LUT
                sample -= DNL_LUT[(int)PED_DATA[i][j]][i];  //usual (voltage) ped substraction
                                
                if(i==0){
                    LOGGED_DATA_CH1 <<sample<<"\n";
                }
                if(i==1){
                    LOGGED_DATA_CH2 <<sample<<"\n";
                }           
                if(i==2){
                    LOGGED_DATA_CH3 <<sample<<"\n";
                }
                if(i==3){
                    LOGGED_DATA_CH4 <<sample<<"\n";
                }       
                if(i==4){
                    LOGGED_DATA_CH5 <<sample<<"\n";
                }    
                if(i==5){
                    LOGGED_DATA_CH6 <<sample<<"\n";
                }  
            }
        }
    }

    LOGGED_DATA_CH1.close();
    LOGGED_DATA_CH2.close();
    LOGGED_DATA_CH3.close();
    LOGGED_DATA_CH4.close();
    LOGGED_DATA_CH5.close();
    LOGGED_DATA_CH6.close();
    cout << "......DONE READ\n";
}
/////////////////////////////////////////////////////////////////// 
void MainWND::LOG_DATA_SCOPE(bool k, unsigned int num_frames, int trig_mode)
{
    LOAD_DNL_LUT();
    LOAD_PED();        
    unsigned int i,j;//,DEBUG;
    unsigned int count = 0; 
    float sample;
    int check_event;
    float pipedat[CHAN][256];
    float DNL_temp;
    
    // Open a pipe to gnuplot (may need changed, depending on gnuplot install) 
    FILE *gnuplotPipe = popen(GNUPLOTpath,"w");  
    // If gnuplot is found: 
    if (gnuplotPipe) {
        cout << "piping data thru gnuplot...\n";
    }  
    // using fprintf on the gnuplotPipe, we can directly issue commands in gnuplot  
    fprintf(gnuplotPipe, "set pointsize .2 \n"); 
    fprintf(gnuplotPipe, "set grid \n"); 
    fprintf(gnuplotPipe, "set autoscale y \n");  
    fprintf(gnuplotPipe, "set xrange [0:32]\n"); 
    fprintf(gnuplotPipe, "set xlabel \'Time [ns]\' \n");
    fprintf(gnuplotPipe, "set ylabel \'Voltage [mV]\' \n");        
    fprintf(gnuplotPipe, PLOTFILEpath);  
    
    while(k != 0){
        count++;
        //take several frames,then ask to continue? --need better way to quit 'scope'
        if(count % num_frames == 0){
            cout << " to continue scoping enter: 1\n to quit enter: 0\n>>";
            cin >> k;
        }  
        FILE* foutd = fopen("LOG_DATA_pipe.txt", "w"); 
         
        if(trig_mode == 0) 
            SOFT_TRIG(); //for debugging
        
        Sleep(1);
        Read(false);
        check_event = 0;
              
        for(i=0;i<CHAN; i++){
            for(j=0;j<256; j++){
                if (i==0 && j < 10)
                    check_event += (int)RAW[i][j];
                    
                sample =  DNL_LUT[(int)RAW[i][j]][i]*1000;  // convert to voltage using LUT
                sample -= DNL_LUT[(int)PED_DATA[i][j]][i]*1000;  //usual (voltage) ped substraction
                pipedat[i][j] = sample;
            }
        }
        for(int g=0;g<256;g++){         
            fprintf(foutd, "%d\t%f\t%f\t%f\t%f\t%f\t%f\t\n",g,pipedat[0][g],pipedat[1][g]
            ,pipedat[2][g],pipedat[3][g],pipedat[4][g],pipedat[5][g]);
        }
        fclose(foutd);   
        Sleep(1);
        
        if(check_event == 0){
            //cout << "no trigger\n";
            fprintf(gnuplotPipe, "plot 0 title \'NO TRIGGER' \n");
        }
        else{
            fprintf(gnuplotPipe, "unset label\n");
            fprintf(gnuplotPipe, "plot \"LOG_DATA_pipe.txt\" using ($1*.1):2 with linespoints title \'CHAN 1', \
            \"LOG_DATA_pipe.txt\" using ($1*.1):3 with linespoints title \'CHAN 2', \
            \"LOG_DATA_pipe.txt\" using ($1*.1):4 with linespoints title \'CHAN 3', \
            \"LOG_DATA_pipe.txt\" using ($1*.1):5 with linespoints title \'CHAN 4', \
            \"LOG_DATA_pipe.txt\" using ($1*.1):6 with linespoints title \'CHAN 5', \
            \"LOG_DATA_pipe.txt\" using ($1*.1):7 with linespoints title \'CHAN 6' \n");
        }

        fflush(gnuplotPipe);
        Sleep(100);              
        //cin >> k;
        //Sleep(1);   
    }   
    
    // exit gnuplot  
    fprintf(gnuplotPipe,"exit \n");  
    pclose(gnuplotPipe);   
    //cout << "......DONE READ\n";
}
///////////////////////////////////////////////////////////////////////////// 
void MainWND::GENERATE_PED()
{
    unsigned int i,j,k;
    unsigned int num_reads = 100;
    unsigned int raw_array[CHAN][256];   
    
    for(i=0;i<CHAN; i++){
        for(j=0;j<256; j++){
            raw_array[i][j]=0;            
        }
    }    
    cout << "START PED_READOUT......\n";
    
    for(k=0;k<num_reads; k++){
      
        printf("PED_READOUT: %d of %d\n",k+1,num_reads);
        SOFT_TRIG(); 
               
        Read(false);       
        for(i=0;i<6; i++){
            for(j=0;j<256; j++){
                raw_array[i][j] += RAW[i][j];
            }
        }    
    }
  
    ofstream SAVE_PED;
    SAVE_PED.open ("PED_DATA.txt",ios::trunc);
    for(i=0;i<CHAN; i++){
        for(j=0;j<256; j++){                              
            PED_DATA[i][j] = raw_array[i][j]/num_reads;
            SAVE_PED<<PED_DATA[i][j]<<"\n";
        }
    }
    SAVE_PED.close();
    cout << "......DONE PED_READOUT\n";
}
///////////////////////////////////////////////////////////////////
void MainWND::LOAD_PED()
{
    unsigned int i,j;
    ifstream LOAD_PED_DATA;
    LOAD_PED_DATA.open ("PED_DATA.txt");
  
    for(i=0;i<CHAN; i++){
        for(j=0;j<256; j++){
            LOAD_PED_DATA >> PED_DATA[i][j];
            //cout << PED_DATA[0][j] << "\n";
        }
    }    
    cout << "PED LOADED!\n";
    LOAD_PED_DATA.close();
}
///////////////////////////////////////////////////////////////////
void MainWND::LOAD_DNL_LUT() //Loads DNL LUT + count/voltage conversion factors
{
    FILE* fin = fopen("LUT.txt", "r");
    if (fin == NULL)
        return;
    
    int rows=0;
    
    while (!feof(fin)) {
        int i;
        char buf[1000];
        
        fgets(buf, 1000, fin);
        
        if (feof(fin))
            continue;
            
        if (count(buf, buf + strlen(buf), '\t') < 6)
            continue;  // not 5-column or more
        
        sscanf(buf, "%d\t", &i);
        
        int tmp;
        sscanf(buf, "%d\t%f\t%f\t%f\t%f\t%f\t%f\t\n", &tmp, &DNL_LUT[i][0], &DNL_LUT[i][1], &DNL_LUT[i][2], 
                &DNL_LUT[i][3], &DNL_LUT[i][4], &DNL_LUT[i][5]);
        //cout << DNL_LUT[i][4] << "\n";
        rows++;
    }
    fclose(fin);
    cout << "LUT LOADED!\n";
}   
///////////////////////////////////////////////////////////////////  
void MainWND::Read(bool ENABLE_TXT)
{
    ofstream myfile2;
    stdUSB in;
    int i,j;
	unsigned short buffer[BUFFERSIZE];
	memset(buffer,0x0,BUFFERSIZE*sizeof(unsigned short));
	//memset(RAW,0x0,BUFFERSIZE*sizeof(int));
	int samples;
	DWORD dw;
	GoodData = true;
	if(in.createHandles() == stdUSB::SUCCEED){
        try
    	{
            in.readData(buffer,BUFFERSIZE, &samples);
            if(ENABLE_TXT != false)
                printf("Samples read %d\n",samples);                                                   
            if(samples >= BUFFERSIZE){
                for(i=0;i<BUFFERSIZE;i++){
                    lastGoodData[i] = buffer[i];
                }
            }
            else
                GoodData = false;
            myfile2.open ("temp.txt",ios::trunc);
         
            for(i=2;i<1545;i++){
                myfile2<<buffer[i]<<" \n";
        		if(ENABLE_TXT != false){
                    printf("%x, ", buffer[i]);
                }
            }
            myfile2.close();

            for(i=0;i<CHAN;i++){   
                for(j=0;j<256;j++){                  	
           	        RAW[i][j] = buffer[2+256*i+j];
                }
            }        
            in.freeHandles();
		}
		catch (DWORD dw){
			cout << "Errorcode %d\n";
		}
		catch(...){
			cout << "Exception...probably a connection related issue.\n";
		}
    }
    else
         cout << "Please connect the board.\n";
}
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
void MainWND::USB_SYNC(bool ENABLE)
{
    stdUSB in;
    in.createHandles();
    if(ENABLE != false)
    {
        in.sendData((unsigned int)0x00010001);//enable USB_SYNC
    }
    else
    {
        in.sendData((unsigned int)0x00000001);//disable USB_SYNC
    }
    in.freeHandles();
}
///////////////////////////////////////////////////////////////////
void MainWND::SOFT_TRIG()
{
    stdUSB in;
    in.createHandles();
    in.sendData((unsigned int)0x00000002);//software trigger
    in.freeHandles();
}
///////////////////////////////////////////////////////////////////
void MainWND::PED_SCAN(unsigned int ADC_VALUE)
{
    stdUSB in;
    in.createHandles();
    const unsigned int mask = 0x00000003;
    unsigned int ManualData;
    ManualData = ADC_VALUE << 16 | mask;//DTRIG discrimator threshold
    in.sendData(ManualData);
    in.freeHandles();
}
///////////////////////////////////////////////////////////////////
void MainWND::USB_DEBUG(unsigned int DEBUG)
{
    stdUSB in;
    in.createHandles();
    const unsigned int mask = 0x000000FF;
    unsigned int ManualData;
    ManualData = DEBUG << 16 | mask;
    in.sendData(ManualData);
    in.freeHandles();
}
///////////////////////////////////////////////////////////////////
void MainWND::TRIG_CNTRL(unsigned int THRESH, bool MODE)
{    
    //bool MODE = 0;  //trig controls
    bool SIGN = 1;
    bool SSlsb = 0;   // sampling speed controls  ---fixed in firmware for jitter considerations!!!!
    bool SSmsb = 0;
    //unsigned int THRESH = 0xF00;
    TRIG_SET = (SSmsb << 15) | (SSlsb << 14) |(MODE << 13) | (SIGN << 12) | THRESH; //16 bit control word
    printf("sampling/trig settings = 0x%x \n", TRIG_SET);
    USB_DEBUG(TRIG_SET);    
} 
///////////////////////////////////////////////////////////////////
void MainWND::DAC_SCAN()
{
    FILE* fout = fopen("LUT.txt", "w");
    //float oldLUT[4096][CHAN];
    //int oldPed[CHAN*256];
    //memcpy(oldLUT, LUT, sizeof(LUT) );
    //memcpy(oldPed, PED_DATA, sizeof(PED_DATA) );
    int temp[CHAN];
    
    for(int i=0; i < 4096; i++)
        LUT[i][0] = LUT[i][1] = LUT[i][2] = LUT[i][3] = LUT[i][4] = LUT[i][5] = -1;
    
    for(int i=10; i<4002; i+=20){        //dac control
        for(int k=0;k<CHAN;k++){
            temp[k] = 0;
        }
        
        dac_level = i;
        float voltage = i * 1.200/4096.0;
        PED_SCAN(i);
        printf("waiting .....PED =%d \n", i);
        Sleep(2000);
        GENERATE_PED();
        
        for(int m=0;m<CHAN; m++){
            for(int j=0;j<256; j++){
                temp[m] += PED_DATA[m][j];
            }
            temp[m] /= 256;
            if (temp[m] > 0 && temp[m] < 4096)
                LUT[temp[m]][m] = voltage;
        }
    }
    // do linear interpolations
    int first, second, j;
    for(int i=0; i < 6; i++) {  // for each channel
        // find first value
        for(j=0; LUT[j][i] < 0; j++);  // don't test equality with floating point #s
        
        first = j;  // first is now the first LUT value
        
        while (j < 4096) {
            for(j++; LUT[j][i] < 0 && j < 4096; j++);
            
            if (j >= 4096) continue;
            
            second = j;
            
            for(int k=first+1; k < second; k++) {
                LUT[k][i] = LUT[first][i] + (float)(k-first)/(second-first) * (LUT[second][i] - LUT[first][i] );
            }

            first = second;
        }
    }
//fprintf(myfile8, "%d\t%f\t%f\t%f\t%f\t%f\t%f\t\n", i, temp[0],temp[1],temp[2],temp[3],temp[4],temp[5]);
    for(int i=0; i < 4096; i++)
        fprintf(fout, "%d\t%f\t%f\t%f\t%f\t%f\t%f\t\n", i,LUT[i][0],LUT[i][1],LUT[i][2],LUT[i][3],LUT[i][4],LUT[i][5]);
    fclose(fout);       
}         

