///////////////////////////////////////////////////////////////////  
//						USB tester
//						
//TESTING ONE, TWO, THREE.
//written 18-Oct-2011 eric oberla
///////////////////////////////////////////////////////////////////  

#include "base.h"
#include <fstream>
#include <Windows.h>
#include <stdio.h>
#include <cstdlib>
#include <iostream>

using namespace std;

int main()
{
    MainWND command;
    cout << "PSEC-4 EVAL USB-tester terminal\n";
    cout << "modified 18-10-2011\n\n";
    int select = 100;
    bool start_scope = 1;
    
    //default ped settings
    int level = 2300;
    int level_temp = 0;
    command.PED_SCAN(level);
    float voltage; 
    
    int threshold = 0x000;
    int threshold_temp = 0x000;
    unsigned int num_readouts = 100;
    unsigned int num_frames = 500;
    int trig_mode = 0;
    
    while( select >= 0 ){ 
        voltage = level*1200/4096;
        
        cout << "\n<:---------------:>\n";
        cout << "enter operation:\n";
        cout << "0: configuration settings, current settings:" << endl;
            if(trig_mode == 0)
                cout << "   --> software triggering\n";
            if(trig_mode == 1)
                cout << "   --> hardware triggering (rising edge)\n";
            if(trig_mode == 2)
                cout << "   --> internal triggering with threshold = " << threshold*1200/4096 << " mV\n";                
        cout << "1: set pedestal level, current settings:" << endl;
            cout << "   --> set to " << voltage << " mV\n";
        cout << "2: single raw readout\n";
        cout << "3: generate pedestal\n";
        cout << "4: generate linearity LUT\n";
        cout << "5: readout to file\n";
        cout << "6: oscilloscope\n>>";
        cin >>  select;
        
        if(select == 0){
            cout << "   0: software trigger\n   1: hardware trigger\n   2: internal trigger\n>>";
            cin >> trig_mode;
            if (trig_mode < 0 || trig_mode >2)
                break;
            else if( trig_mode == 0){
                command.USB_SYNC(false);
                cout << "USB_SYNC disabled - software trig testing" << endl;
            }
            else{
                command.USB_SYNC(true); 
                cout << "USB_SYNC enabled" << endl; 
                
                if(trig_mode == 1){
                    command.TRIG_CNTRL(0xFF0, false);
                    cout << "hardware triggering --> rising edge: 3V logic\n";
                    continue;
                }
                
                if(trig_mode == 2)
                    cout << "internal triggering, enter trigger threshold [0->4095]" << endl <<">>";
                    cin >> threshold_temp;
                    if(threshold_temp > 4095){
                        cout << "invalid entry!\n\n";
                        continue;
                    }
                    else if(threshold_temp < 0) continue;
                    else{
                        threshold = threshold_temp;
                        command.TRIG_CNTRL(threshold, true);
                        cout << "setting threshold...\n";
                        Sleep(2000);
                        cout << "threshold set!\n";
                    }
            }
        }
        //change pedestal offset
        if(select == 1){
            cout << "enter pededstal voltage [0->4095] or -1 to return\n>>";
            cin >> level_temp;
            if(level_temp > 4095){
                cout << "invalid entry!\n\n";
                continue;
            }
            else if(level_temp < 0) continue;
            else{
                level = level_temp;
                command.PED_SCAN(level);
                cout << "setting level...\n";
                Sleep(2000);
                cout << "level set!\n";
                //printf("pedestal voltage set to %f mV\n\n", level);
            }
        }
        //raw readout
        if(select == 2){
            command.SOFT_TRIG();
            command.Read(true);
            cout << "\nsent to file: temp.txt";
        }
        
        if(select == 3){
            command.GENERATE_PED();
        }
        
        if(select == 4){
            command.DAC_SCAN();
            level = command.dac_level;
        }
        
        if(select == 5){
            cout << "enter number of readouts: \n>>";
            cin >> num_readouts;
            command.LOG_DATA(num_readouts, trig_mode);
        } 
        if(select == 6){ 
            cout << "enter number of frames (i.e. 500): \n>>";
            cin >> num_frames;
            command.LOG_DATA_SCOPE(start_scope, num_frames, trig_mode);
        }
        else if(select > 6){
            cout << "invalid entry!\n\n";
            continue;
        }
    
    //system("PAUSE");
    }
    return EXIT_SUCCESS;
}
